package org.jeecg.modules.qualityControl.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.qualityControl.entity.FdQcBiometricSampleAnalysisItems;
import org.jeecg.modules.qualityControl.service.IFdQcBiometricSampleAnalysisItemsService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.qualityControl.service.IFdQcBiometricSampleAnalysisService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 质量保证（生物样本分析）明细
 * @author： jeecg-boot
 * @date：   2019-06-12
 * @version： V1.0
 */
@RestController
@RequestMapping("/qualityControl/fdQcBiometricSampleAnalysisItems")
@Slf4j
public class FdQcBiometricSampleAnalysisItemsController {
	@Autowired
	private IFdQcBiometricSampleAnalysisItemsService fdQcBiometricSampleAnalysisItemsService;

	@Autowired
	private IFdQcBiometricSampleAnalysisService iFdQcBiometricSampleAnalysisService;
	/**
	  * 分页列表查询
	 * @param fdQcBiometricSampleAnalysisItems
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FdQcBiometricSampleAnalysisItems>> queryPageList(FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FdQcBiometricSampleAnalysisItems>> result = new Result<IPage<FdQcBiometricSampleAnalysisItems>>();
		QueryWrapper<FdQcBiometricSampleAnalysisItems> queryWrapper = QueryGenerator.initQueryWrapper(fdQcBiometricSampleAnalysisItems, req.getParameterMap());
		queryWrapper.lambda().orderByAsc(FdQcBiometricSampleAnalysisItems::getSort);
		Page<FdQcBiometricSampleAnalysisItems> page = new Page<FdQcBiometricSampleAnalysisItems>(pageNo, pageSize);
		IPage<FdQcBiometricSampleAnalysisItems> pageList = fdQcBiometricSampleAnalysisItemsService.page(page, queryWrapper);
		//获取对应图片集合
		iFdQcBiometricSampleAnalysisService.getPictureUpload(pageList.getRecords());
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fdQcBiometricSampleAnalysisItems
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FdQcBiometricSampleAnalysisItems> add(@RequestBody FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems) {
		Result<FdQcBiometricSampleAnalysisItems> result = new Result<FdQcBiometricSampleAnalysisItems>();
		try {
			fdQcBiometricSampleAnalysisItemsService.save(fdQcBiometricSampleAnalysisItems);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fdQcBiometricSampleAnalysisItems
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FdQcBiometricSampleAnalysisItems> edit(@RequestBody FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems) {
		Result<FdQcBiometricSampleAnalysisItems> result = new Result<FdQcBiometricSampleAnalysisItems>();
		FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItemsEntity = fdQcBiometricSampleAnalysisItemsService.getById(fdQcBiometricSampleAnalysisItems.getId());
		if(fdQcBiometricSampleAnalysisItemsEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdQcBiometricSampleAnalysisItemsService.updateById(fdQcBiometricSampleAnalysisItems);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FdQcBiometricSampleAnalysisItems> delete(@RequestParam(name="id",required=true) String id) {
		Result<FdQcBiometricSampleAnalysisItems> result = new Result<FdQcBiometricSampleAnalysisItems>();
		FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems = fdQcBiometricSampleAnalysisItemsService.getById(id);
		if(fdQcBiometricSampleAnalysisItems==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdQcBiometricSampleAnalysisItemsService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FdQcBiometricSampleAnalysisItems> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FdQcBiometricSampleAnalysisItems> result = new Result<FdQcBiometricSampleAnalysisItems>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fdQcBiometricSampleAnalysisItemsService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FdQcBiometricSampleAnalysisItems> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FdQcBiometricSampleAnalysisItems> result = new Result<FdQcBiometricSampleAnalysisItems>();
		FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems = fdQcBiometricSampleAnalysisItemsService.getById(id);
		if(fdQcBiometricSampleAnalysisItems==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fdQcBiometricSampleAnalysisItems);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FdQcBiometricSampleAnalysisItems> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItems = JSON.parseObject(deString, FdQcBiometricSampleAnalysisItems.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fdQcBiometricSampleAnalysisItems, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FdQcBiometricSampleAnalysisItems> pageList = fdQcBiometricSampleAnalysisItemsService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "质量保证（生物样本分析）明细列表");
      mv.addObject(NormalExcelConstants.CLASS, FdQcBiometricSampleAnalysisItems.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("质量保证（生物样本分析）明细列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FdQcBiometricSampleAnalysisItems> listFdQcBiometricSampleAnalysisItemss = ExcelImportUtil.importExcel(file.getInputStream(), FdQcBiometricSampleAnalysisItems.class, params);
              for (FdQcBiometricSampleAnalysisItems fdQcBiometricSampleAnalysisItemsExcel : listFdQcBiometricSampleAnalysisItemss) {
                  fdQcBiometricSampleAnalysisItemsService.save(fdQcBiometricSampleAnalysisItemsExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFdQcBiometricSampleAnalysisItemss.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
